QGIS Application - Feature request #9471
attribute table isn't refreshed after save
2014-01-31 06:23 AM - Vincent Mora

Status: Open

Priority: Normal

Assignee: Matthias Kuhn

Category: Unknown

Pull Request or Patch supplied: Resolution:

Easy fix?: No Copied to github as #: 18063
Description

This is an issue when you have underlying triggers that will change the table when you save your modifications.

The only workaround is to close and reopen the table.

The refresh can be used to fix #1659

History

#1 - 2014-01-31 10:42 PM - Matthias Kuhn

- Assignee set to Matthias Kuhn

Hi Vincent,

Is this an issue in both, 2.0.1 and master? | have just yesterday been working on auto-updates (so be sure to test with latest master) to the table and wrote
a mail [1] to the dev-ml yesterday which could very likely be related to this issue.

If this is a plugin of yours, make sure, that

- Changes are written to the layer and not the dataprovider directly.
- Changes are made wrapped in beginEditCommand() / endEditCommand()

If the second point fixes this issue for you, can you please give me a short notice. That would be the answer to my mail [1] and could easily be fixed.

PS: | will be away for the next week. If you find anything concerning this, can you write me a PM, so | don't forget about this when | get back. Thank you.

[1] http://lists.osgeo.org/pipermail/qgis-developer/2014-January/030694.html

#2 - 2014-02-02 03:23 AM - Vincent Mora
- File test_9471.qgs added
- File test_9471.sqlite added

Hi Matthias,

Is this an issue in both, 2.0.1 and master? | have just yesterday been working on auto-updates (so be sure to test with latest master) to the table and

wrote a mail [1] to the dev-ml yesterday which could very likely be related to this issue.

I'm working on master (I did not check for 2.0.1). Thanks for pointing your mail on the ML, as far as | understand it's related to this issue.
http://lists.osgeo.org/pipermail/qgis-developer/2014-January/030694.html

If this is a plugin of yours, make sure, that

Nope, it's not a plugin. | have a spatialite trigger that removes a feature when a related feature is removed. | use the attribute table to do the removal, but
the feature that is deleted by the trigger when | save still appears in the table, | have to close and reopen to have an updated view (i.e. for the feature
deleted by the trigger to disappear).

| tested this morning with the latest master, an the problem is still there (are you referring to commit d378f942a50 in you mail on the ML ?).

| join a simple test, if you open the attribute table and delete one feature, both are delete by a spatialite trigger.

#3 - 2014-02-09 04:35 AM - Matthias Kuhn

There is currently no possibility for a provider to push change-notifications back to QGIS. We would need a new API for push-notifications from providers in
QGIS itself and most likely also a plugin for backends to push these notifications to the QGIS providers. The implementation mentioned in my last post only
referred to changes made from inside QGIS.

| am not convinced that a automatic reload after save is the right thing to do. It can introduce a rather big overhead and is likely to actually miss events

(e.g. a trigger updating a different layer). Instead | would prefer to have abovementioned support for push-notifications or as an easier short-term solution
an optional switch to toggle this behaviour. Maybe it would also be feasible to implement this kind of thing in a plugin (similar to this but including some way
to also force the attribute table to be reloaded)

PS: Yes, | was referring to commit:3ba33d7 and commit:d378f94

#4 - 2014-02-10 09:20 AM - Vincent Mora
- Tracker changed from Bug report to Feature request

It can introduce a rather big overhead and is likely to actually miss events (e.g. a trigger updating a different layer)

Isn't ggis reloading geometries every time you pan/zoom/refresh, it also reload data if you close/open the attribute table ?

But you're right, it will miss events.

What about a Refresh button, the same as in the main window, in the attribute table for a short an easier term solution?

| experimented with QgsAttribute TableModel::reload(const QModellndex &index1, const QModellndex &index2 ) (by calling that after save) but with no

effect, is there a cache to dirty or something else ?

Anyway, | changed the status from Bug to Feature request.

#5 - 2014-02-11 12:56 AM - Matthias Kuhn

did you try to call QgsAttributeTableModel::loadLayer() ? | reckon that should refresh the cache as well.

A refresh button would be an acceptable solution | think.

#6 - 2014-06-19 12:53 PM - Antonio Locandro
http://gis.stackexchange.com/questions/58814/how-to-automatically-reloaded-raster-layer-if-source-is-changed-in-qgis/58885#58885

Wouldn't it be possible that upon toggling editing the attribute table would refresh itself without the need for a refresh button or close/open again?

#7 - 2014-08-02 09:49 AM - Antonio Locandro
Adding again to this, the desired behaviour would be once you click stop editing, after committing changes QGIS would automatically refresh the table,
there is no reason why | should press refresh to do that when the software can do it for me, it's an extra click that if you multiply for several hundreds of
edits equals a lot of wasted time
#8 - 2014-08-03 01:48 AM - Matthias Kuhn
There are IMO two reasons why the approach is wrong:

- The loading will take place regardless if it's necessary. If there are no triggers (and that's not uncommon) or only unrelated columns are edited it
introduces a lot of "wasted time" as well.

- Data may be changed from outside. (E.g. from a plugin without toggling the layer's edit state by accessing layer.dataProvider() directly). In that case
the table ought to be reloaded but isn't.
Therefore, the proposed trigger event (save layer) is not adequate and leads do performance degradation in many cases.
What could be discussed is a layer option that needs to be manually turned on (or if there is a good indicator for auto-detection, that's fine as well of
course).
#9 - 2017-05-01 12:47 AM - Giovanni Manghi

- Easy fix? set to No

#10 - 2017-09-22 10:07 AM - Jiirgen Fischer
- Category set to Unknown

Files
test_9471.qgs 6.73 KB 2014-02-02 Vincent Mora
test_9471.sqlite 4.1 MB 2014-02-02 Vincent Mora
